/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
@AllArgsConstructor
public enum WaterDestroyMode implements Flag.Value<WaterDestroyMode> {

    ALLOW("FLAG_WATER_DESTROY_ALLOW"),
    DENY("FLAG_WATER_DESTROY_DENY");

    private static WaterDestroyMode[] values;
    private final String chatValue;

    @Override
    public WaterDestroyMode[] getValues() {
        if (WaterDestroyMode.values == null) {
            WaterDestroyMode.values = WaterDestroyMode.values();
        }
        return WaterDestroyMode.values;
    }

    @Override
    public WaterDestroyMode getValue() {
        return this;
    }

    @Override
    public WaterDestroyMode getValueOf(final String name) {
        try {
            return WaterDestroyMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            return ALLOW;
        }
    }
}